#!/usr/bin/perl

use 5.010;
use strict;
use JSON;

print "f[^t@C(.csv)w肵ĂB\n";
chomp(my $dataFile = <STDIN>);
print "f[^ǂݍł܂B\n";

my $start        = time;
my $dataSize     = 0;
my %favorite 	 = ();
my %favoriteUser = ();
my %favoriteItem = ();
open(IN, $dataFile);
while(<IN>){

    chomp;

   	my @d = split(/,/, $_);

	if( defined($favorite{$d[0]}{$d[1]}) ){

		#skip

	}else{

		push(@{$favoriteUser{$d[1]}},$d[0]);

		push(@{$favoriteItem{$d[0]}},$d[1]);

		$favorite{$d[0]}{$d[1]} = 1;
	
	}

}
close(IN);
undef(%favorite);

print "f[^̓ǂݍ݂܂B\n";
my $gd = time - $start;
print "܂ł$gdb܂B\n";
print "RTCގxvZĂ܂B\n";


my %similar  = ();
my @user 	 = keys(%favoriteItem);
my @item     = keys(%favoriteUser);
my $userSize = @user;

for(my $i = 0; $i<=$#item; $i++){

	for(my $j = $i + 1;  $j<=$#item; $j++){

		my @u = ();

		push(@u,@{$favoriteUser{$item[$i]}});
		push(@u,@{$favoriteUser{$item[$j]}});

		my $inner = 0;

		my %count = ();

		for (my $k=0; $k<=$#u; $k++ ) {

			$count{$u[$k]}++;

			if($count{$u[$k]}==2){

				$inner++;

			}

		}

		if( $inner > 0 ){

			my $k 		 = $inner;
			my $x 		 = @{$favoriteUser{$item[$i]}};
			my $y 		 = @{$favoriteUser{$item[$j]}};
		
			my $cos      = $inner/($x*$y)**(1/2);

			$similar{$item[$i]}{$item[$j]} = $cos;
			$similar{$item[$j]}{$item[$i]} = $cos;

		}
	}
}

print "RTCގx̌vZ܂B\n";
my $cc = time - $start;
print "܂ł$ccb܂B\n";

print "e[U[ɃACeE܂Hipj\n";
chomp(my $threshold = int(<STDIN>));
print "łBEsĂ܂B\n";

my %recommendForUsers = ();

for( my $i = 0; $i < $userSize; $i++){

	my @fs = @{$favoriteItem{$user[$i]}};

	my %r = ();

	my %skip = ();

	for (my $k=0; $k<=$#fs; $k++ ) {

		$skip{$fs[$k]} = 1;

	}
	

	for( my $ j = 0; $j <= $#fs; $j++ ){

		my $s = $fs[$j];

		for( my $k = 0; $k <=$#item; $k++){

			if( $skip{$item[$k]} ){

				#skip;

			}else{

				$r{$item[$k]} = $r{$item[$k]} + $similar{$s}{$item[$k]};

			}

		}

	}

	my $recommendNum      = 0;
	foreach my $key (sort { $r{$b} <=> $r{$a} } keys %r){

		push(@{$recommendForUsers{$user[$i]}},$key);

		$recommendNum++;

		if($recommendNum >= $threshold){

			last;

		}

	}

}

print "E܂B\n";
print "eACeɗގACeE܂Hipj\n";
chomp(my $threshold = int(<STDIN>));
print "łBEsĂ܂B\n";

my %similarItems  = ();

for( my $i = 0; $i <= $#item; $i++){

	my %r = %{$similar{$item[$i]}};
	my $recommendNum  = 0;

	foreach my $key (sort { $r{$b} <=> $r{$a} } keys %r){

		push(@{$similarItems{$item[$i]}},$key);

		$recommendNum++;

		if($recommendNum >= $threshold){

			last;

		}

	}

}

print "E܂B\n";
print "JSt@Co͂Ă܂B\n";

#o

unlink './recommendForUsers.js';
open(DATAFILE, ">> ./recommendForUsers.js");

print DATAFILE "var recommendForUsers = \n";
print DATAFILE JSON::XS->new->pretty(1)->encode(\%recommendForUsers);
print DATAFILE ";\n";

close DATAFILE;

unlink './similarItems.js';
open(DATAFILE, ">> ./similarItems.js");

print DATAFILE "var similarItems = \n";
print DATAFILE JSON::XS->new->pretty(1)->encode(\%similarItems);
print DATAFILE ";\n";

close DATAFILE;

exit;



